#ifndef _DB_H_
#define _DB_H_
#include <stdio.h>

typedef struct record RECORD;

/* this struct defines a table, whose length is the number of
 * records in this table. And its width defines the number of
 * fields in a table/database
 *
 * Here, the length and the width of the table are both dynamically
 * determined.
 */

struct database {
  int numOfRecs; /* record number */
  int numOfItems; /* field number */
  int * table; /* list of records */
  int * transId;
};

typedef struct database DBASE;

/* allocate memory for a record or for a databse */
DBASE * newDb( int, int );

/* read from file */
DBASE * readFrom( FILE * );
void report( DBASE * );

/* remove record or database from memory */
/* void delRec( RECORD * ); */
void delDb( DBASE * );

/* insert a record in database at specified offset */
/* void insertRecAt( DBASE *, int, RECORD * ); */

/* finding out the sum of a field */
int sumOfField( int * , int, int, int );

#define DATAITEM(tbl,i,j) ((tbl)[i*numOfItems+j])

#endif
